unit uModinv;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ePhiN: TEdit;
    lPhiN: TLabel;
    eE: TEdit;
    lE: TLabel;
    bBerechne: TButton;
    mAusgabe: TMemo;
    bLoesche: TButton;
    procedure bBerechneClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bBerechneClick(Sender: TObject);
var
  phiN,e,g,x,y,d,k : int64;
  s            : string;

  // Herrmann, Algorithmen Arbeitsbuch, S.138
  procedure Lagrange(a,b : int64; var x,y,ggt : int64);
  var
    q,r,t,u,v : integer;
  begin
    x := 0; y := 1;
    u := 1; v := 0;
    q := a div b; r := a mod b;
    while r > 0 do
    begin
      a := b; b := r;
      t := u; u := x; x := t-q*x;
      t := v; v := y; y := t-q*y;
      q := a div b; r := a mod b;
    end;
    ggt := b;
  end;

begin
  phiN := StrToInt(ePhiN.text); e := StrToInt(eE.text);

  Lagrange(phiN,e,x,y,g);

  if y < 0
  then
    begin
      d := phiN+y; k := x+e; // entspricht Addition von e*phi(n)
    end
  else
    begin
      d := y; k := -x;
    end;

  s := IntToStr(g)+' = '+IntToStr(x)+'*'+IntToStr(phiN)+' + '+
                         IntToStr(y)+'*'+IntToStr(e);
  mAusgabe.Lines.Add(s);
  s := IntToStr(e)+'*'+IntToStr(d)+' = '+IntToStr(k)+'*'+IntToStr(phiN)+' + '+
                         IntToStr(g);
  mAusgabe.Lines.Add(s);
end;

procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mAusgabe.Clear;
end;

end.
